#ifndef _CBAS
#define _CBAS
#include "Bass.h"
#include "logging.h"
#include "3dmath.h"

HSTREAM soundStream;



void initSound(){
     if(!BASS_Init(-1,44100,BASS_DEVICE_3D,GetForegroundWindow()))	
          if(BASS_ErrorGetCode()==BASS_ERROR_NO3D){
                                                   log_txt("Kein 3D-Sound unterstuetzt! Es wird nur Hintergrundmusik gespielt");
                                                   BASS_Init(-1,44100,0,GetForegroundWindow());
          }
     BASS_Set3DFactors(0.0001,0.6,-1);
}

void killSound(){
     BASS_Free();
}

void playSound(char *file,int vol=75){
     soundStream=BASS_StreamCreateFile(FALSE,file,0,0,0);
     BASS_Start();
	 BASS_StreamPlay(soundStream,FALSE,BASS_SAMPLE_LOOP);
	 BASS_ChannelSetAttributes(soundStream,-1,vol,-101);
}

HSTREAM load3DSound(char *file){
        return BASS_StreamCreateFile(FALSE,file,0,0,BASS_SAMPLE_3D);
        
}

void play3DSound(HSTREAM str){
     BASS_Start();
	 BASS_StreamPlay(str,FALSE,BASS_SAMPLE_LOOP);     
}



void move3DSound(HSTREAM str,float x, float y, float z, float speed, Vertex posi, Vertex viewdir){
     BASS_3DVECTOR *pos;
     pos=(BASS_3DVECTOR *)malloc(sizeof(BASS_3DVECTOR));
     Vertex origin=newV(0,0,1);
     float alpha=dotProduct(viewdir,origin);
     float dist=vlength(sub(newV(x,y,z),posi));
     float betta=dotProduct(origin,sub(newV(x,y,z),posi));
     float gamma=alpha-betta;
     
     pos->x=(x-posi.x)/100/sin(DEG2RAD*betta)*-sin(DEG2RAD*gamma);
     pos->y=(y-posi.y)/100;
     if(viewdir.x>=0)
     pos->z=(z-posi.z)/100/cos(DEG2RAD*betta)*(cos(DEG2RAD*gamma));
     else
     pos->z=(z-posi.z)/100/cos(DEG2RAD*betta)*(-cos(DEG2RAD*gamma));
     
     
     
     BASS_ChannelSetAttributes(str,9000+3000*speed,-1,-101);
     BASS_ChannelSet3DPosition(str,pos,NULL,NULL);     
     
     
}



void stop3DSound(HSTREAM str){
     BASS_ChannelStop(str);
}

void new3DPos(){
     
     BASS_Apply3D();
    
}
     

void stopSound(){
     BASS_Stop();
}

float CPUusage(){
      return BASS_GetCPU();
}


#endif

