#ifndef _WATER
#define _WATER

#include "shader.h"

#define STEP 1000

class Water{
      public:
             int height;
             int maxview;
             int shd_param;
             texture_t tex[6];
             glShader water_shader;
             texture_t screenimage;
      private:
              float frames;
      public:      
             Water(){}
             
             Water(int h, int max,char shader1[50],char shader2[50]){
                      height=h;
                      maxview=max; 
                      frames=0;  
                      shd_param=0;   
                      
                      glGenTextures(1,&screenimage.texID);    
                      glBindTexture(GL_TEXTURE_2D,screenimage.texID);
            
                      unsigned char* imgData=(unsigned char*)malloc(sizeof(unsigned char)*resx*resy*3);
                      glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,resx-1,resy-1,0,GL_RGB,GL_UNSIGNED_BYTE,imgData);
                      delete [] imgData;    

            
                      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
                      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
                      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
                      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);                 
                      water_shader=LoadGLShader(shader1,shader2);
             } 
             
             void initTex(){
                       tex[0]=LoadTexture(tex[0].name,false);
                       tex[1]=LoadTexture(tex[1].name,false);
                       tex[2]=LoadTexture(tex[2].name,false);
                       tex[3]=LoadTexture(tex[3].name,false);
                       tex[4]=LoadTexture(tex[4].name,false);
                       tex[5]=LoadTexture(tex[5].name,false);          
             }    
             
             void draw(bool shader, int offset=0){
                
                
                if(shader){
                    glBindTexture(GL_TEXTURE_2D,screenimage.texID);
                    glCopyTexImage2D(GL_TEXTURE_2D,0,GL_RGB,0,0,resx-1,resy-1,0);          
                    
                    glPushMatrix();
                    glMatrixMode(GL_PROJECTION);		// set projection matrix current matrix
        			glLoadIdentity();					// reset projection matrix	// calculate aspect ratio of window
        			
        			glOrtho( 0, resx , resy , 0, -1, 1 );							// Select Ortho Mode (640x480)
        
        			glMatrixMode(GL_MODELVIEW);			// set modelview matrix
        			glLoadIdentity();
                    
                    
                    glDisable(GL_DEPTH_TEST);
                    glClear(GL_STENCIL_BUFFER_BIT);
                    glDepthMask(0);
                    
                    
                    
                    glEnable(GL_STENCIL_TEST);
                    glStencilFunc(GL_ALWAYS,2,1);
                    glStencilOp(GL_REPLACE,GL_REPLACE,GL_REPLACE);
                        glColorMask(0,0,0,0);
                        
                        glBegin(GL_QUADS);
                          
                          for(int x=-int(maxview);x<=int(1.5*maxview);x+=STEP){
                                 for(int y=-int(maxview);y<=int(1.5*maxview);y+=STEP){
                                      glTexVerti(0,0,x,height,-y,1); 
                                      glTexVerti(1,0,x+STEP,height,-y,1);  
                                      glTexVerti(1,1,x+STEP,height,-y+STEP,1);  
                                      glTexVerti(0,1,x,height,-y+STEP,1);            
                                 }         
                          }
                        glEnd();  
                    glEnable(GL_DEPTH_TEST);    
                    glColorMask(1,1,1,1);
                    glColor3f(1.0,1.0,1.0);
                    glStencilFunc(GL_GREATER,1,1);
                    glStencilOp(GL_KEEP,GL_KEEP,GL_KEEP);
                    glBindShader(water_shader);
                    glBindTex(screenimage,0);
                    glPassTexToShader(water_shader,"texUnit0");
                    glUniform1iARB(glGUL(water_shader,"param"),shd_param);
                    glUniform1iARB(glGUL(water_shader,"y_offset"),offset);
                    glUniform1iARB(glGUL(water_shader,"wave"),(rand()%100)-50);
                    shd_param++;
                    
                    if(shd_param>=20*M_PI) shd_param=1;
                    glBegin(GL_QUADS);               
                       glTexCoordARB(0,1,0);glVertex2f(0,0);
                       glTexCoordARB(0,0,0);glVertex2f(0,resy);
                       glTexCoordARB(1,0,0);glVertex2f(resx,resy);
                       glTexCoordARB(1,1,0);glVertex2f(resx,0);
                    glEnd();
                    glUnbindShader();
                    
                    glDepthMask(1); 
                    glDisable(GL_STENCIL_TEST);
                    
                    glMatrixMode(GL_PROJECTION);                        // Select The Projection Matrix
                    glLoadIdentity();                                // Reset The Projection Matrix
    
                    // Calculate The Aspect Ratio Of The Window
                    gluPerspective(45.0f,(GLfloat)resx/(GLfloat)resy,0.1f,9999999.0f);
    
                    glMatrixMode(GL_MODELVIEW);                        // Select The Modelview Matrix
                    glPopMatrix();                           // Reset The Modelview Matrix 
                }  
                  
                  glEnable(GL_BLEND);
                  glColor4f(1.0f, 1.0f, 1.0f, 0.5f);
                    
                  glBindTex(tex[(int)floor(frames)],1);
                  
                  glBegin(GL_QUADS);
                  
                  for(int x=-int(maxview);x<=int(1.5*maxview);x+=STEP){
                         for(int y=-int(maxview);y<=int(1.5*maxview);y+=STEP){
                              glTexVerti(0,0,x,height,-y,1); 
                              glTexVerti(1,0,x+STEP,height,-y,1);  
                              glTexVerti(1,1,x+STEP,height,-y+STEP,1);  
                              glTexVerti(0,1,x,height,-y+STEP,1);            
                         }         
                  }
                  glEnd();
                  glDisable(GL_BLEND);
                  glUnbindAll();
                  frames+=0.25;
                  if(frames>=6) frames=0;//*/
             }
};

#endif