#include "framework/opengl.h"
#include "framework/Terrain.h"
#include "framework/antialias.h"
#include "framework/shader.h"

//Already defied in Menu.h
//#define GK(x) if(keys[x])
//#define GKT(x) if(!keys[x] && keytemp[x])
//bool keytemp[256];
char fontstr[50],terrastr[50],soundfile[50],logofile[50];
char shader1[50],shader2[50];
ModelInstance models[MAXMODELS];
int modelnr;

//texture_t ftex; from menu.h
CTimer timer;
int fps;
Vertex pos, viewdir;
Terrain terra;
Camera cam;
double timespan=0;

float fpsq;


Skybox sky;
int actmodel;
bool firstdone=false;
texture_t ftex;
Water wat;
glShader shadow_shd;
POINT mpos;

bool settings[10];
//settings[0]=Aliasing
//settings[1]=water shader
//settings[2]=splitscreen

//**********************************************************
//Sets everything to start-pos
//**********************************************************


void InitPositions(){
        log_txt("Initializing Positions...");

        cam.yaw=0;
        cam.yrot=45;
        cam.pos.x=200;
        cam.pos.z=200;
        cam.speed=0;
        cam.pos.y=terra.getIUSHeight(200,200)+10;
        cam.init(cam.pos.x,cam.pos.y,cam.pos.z,0,0,1,terra.scale*(terra.max-2));
        cam.update(1);
        cam.positionCamera();
        log_txt("Positions initialized!");
}

void initShadowTex(){
        glViewport(0,0,1024,1024);
        //glViewport(0,0,resy,resy);
        glClearColor(1,1,1,1);
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);        // Clear The Screen And The Depth Buffer
        glUnbindAll();
        glColor3f(1,1,1);
       
        
        cam.yrot=180;
        cam.update(1);
        cam.positionCamera();
        glTranslatef(-terra.max*terra.scale*0.5,terra.max*terra.scale*0.5,-30000);
        glRotatef(90,-1.0,0.0,0.0);        
        glTranslatef(0,60000,0);
        terra.renderTerrainDepth();
        
        for(int x=0;x<modelnr;x++){
                                  models[x].SetModelPos();
                                  terra.models[models[x].parentNR].RenderFrame();
                                  glPopMatrix();
        }
        
        glBindTexture(GL_TEXTURE_2D,terra.shadows.texID);
        glCopyTexImage2D(GL_TEXTURE_2D,0,GL_RGB,0,0,1024,1024,0);
        
        glClearColor(0,0,0,1);
        glViewport(0,0,resx,resy);
}


// All Setup For OpenGL Goes Here

int InitGL(GLvoid)
{

        FILE *config;
        config=fopen("data/settings.txt","rt");

        fscanf(config,"\n[FILES]\n\n");
        fscanf(config,"FONT: %s \n",&fontstr);
        fscanf(config,"LOGO: %s\n",&logofile);
        fscanf(config,"TERRAIN: %s \n",&terrastr);
        char modelfile[50], carfile[50];
        fscanf(config,"MODELPOS: %s\n",&modelfile);
        fscanf(config,"CARFILE: %s\n",&carfile);
        fscanf(config,"SOUND: %s\n",&soundfile);
        initSound();
        playSound(soundfile);
        fscanf(config,"CARSOUND: %s\n",&soundfile);
        //carsnd=load3DSound(soundfile);
        fscanf(config,"SKY: %s\n",&carfile);
        
        MultiTexturing();
        if(multitex) initAntialias();
        initGLShader(false);
        fscanf(config,"SHADOW_VERTEX_SHADER: %s\n",&shader1);
        fscanf(config,"SHADOW_FRAGMENT_SHADER: %s\n",&shader2);
        shadow_shd=LoadGLShader(shader1,shader2);
        fscanf(config,"WATER_VERTEX_SHADER: %s\n",&shader1);
        fscanf(config,"WATER_FRAGMENT_SHADER: %s\n",&shader2);
        fclose(config);
        
        timer.Init();
        fps=0;

        terra.init(terrastr);
        wat=Water(terra.hscale*14,terra.max*terra.scale+terra.MaxView,shader1,shader2);
        sprintf(wat.tex[0].name,"data/levels/caustic_001.bmp");
        sprintf(wat.tex[1].name,"data/levels/caustic_002.bmp");
        sprintf(wat.tex[2].name,"data/levels/caustic_003.bmp");
        sprintf(wat.tex[3].name,"data/levels/caustic_004.bmp");
        sprintf(wat.tex[4].name,"data/levels/caustic_005.bmp");
        sprintf(wat.tex[5].name,"data/levels/caustic_006.bmp");
        wat.initTex();
        sky=Skybox(carfile,terra.MaxView,terra.max*terra.scale,terra.hscale);
        glClearColor(0,0,0,1);
        ftex=LoadTexture(fontstr,false);
        glBuildFont(ftex);
        glEnable(GL_TEXTURE_2D);
        glShadeModel(GL_SMOOTH);
		glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
		
		cam=Camera();

        modelnr=0;
        log_txt("Loading Modelpositions from %s",modelfile);
        config=fopen(modelfile,"rt");
        fscanf(config,"[MODELS]\nMODELINSTANCENR: %i\n\n",&modelnr);

        for(int x=0;x<modelnr;x++){
                fscanf(config,"NR:%i X:%f Y:%f Z:%f RX:%f RY:%f RZ:%f SC:%f\n",&models[x].parentNR,&models[x].pos.x,&models[x].pos.y,&models[x].pos.z,&models[x].rot.x,&models[x].rot.y,&models[x].rot.z,&models[x].scale);
                models[x].pos.y=terra.getIUSHeight(models[x].pos.x,models[x].pos.z)-30;
                models[x].anim=0;
        }
        for(int i=0;i<10; i++)
                settings[i]=true;
                
        settings[0]=false;
        settings[2]=false;
        
        
          
        InitPositions();  
        initLogo(logofile);


        return TRUE;
                                                                   // Initialization Went OK
}
//**********************************************************
//getKeys for Input handling
//**********************************************************

void getKeys(){
     for(int x=0;x<256;x++) if(keys[x]) keytemp[x]=true;
     //for moving the car



        //Camera movement
        GK(VK_UP) cam.accelerate(0.45*fpsq);
        GK(VK_DOWN) cam.slowdown_reverse(0.45*fpsq);


        GK(VK_LEFT) cam.look_left(0.45*fpsq);
    	GK(VK_RIGHT) cam.look_right(0.45*fpsq);
        GK(VK_PRIOR) cam.look_up(0.45*fpsq);
        GK(VK_NEXT) cam.look_down(0.45*fpsq);
        GK(VK_SPACE) cam.stop();

        GKT('A'){
                 settings[0]=!settings[0];
                 keytemp['A']=false;
        }
        
        GKT('S'){
                 settings[1]=!settings[1];
                 keytemp['S']=false;
        }

        GKT(VK_END){
                           keytemp[VK_END]=false;
                           log_txt("******************************************+\nReset!\n********************************************");
                           InitPositions();
        }
        
        GKT('2'){
                 keytemp['2']=false;
                 settings[2]=!settings[2];
                 }
        GetCursorPos(&mpos);				// Get The Current Mouse Position
	    SetCursorPos(200,200);				// Set The Mouse Position To The Center Of The Window
	    cam.yaw+=float(200 - mpos.y)/50 * 5;
	    cam.yrot-=float(200 - mpos.x)/50 * 5;
}//getKeys





//da muss die zeichenscheie rein
int DrawGLScene(GLvoid)                                                // Here's Where We Do All The Drawing
{

        GK(VK_F1){//Helpscreen
                glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);        // Clear The Screen And The Depth Buffer
                glLoadIdentity();
                glPrint(255,0,0, 300,60,"3D-Caste Controls",(int)cam.yrot);
                glPrint(192,192,192,270,100,"Uparrow   -   Forward");
                glPrint(192,192,192,270,140,"Downarrow -   Break/Back");
                glPrint(192,192,192,270,180,"Leftarrow -   Steer/look left");
                glPrint(192,192,192,270,220,"Rightarrow-   Steer/look right");
                glPrint(192,192,192,270,260,"Space     -   Stop");
                glPrint(192,192,192,270,300,"End       -   Reset");
                glPrint(192,192,192,270,340,"A         -   Switch Antialiasing on/off");
                glPrint(192,192,192,270,380,"S       -     Switch Shaders on/off");
                glPrint(192,192,192,270,420,"Use Mouse for looking around!");
                glPrint(255,255,255,270,500,"ESC       -   Quit");
        }
        else{
        
        getKeys();
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);        // Clear The Screen And The Depth Buffer
        glLoadIdentity();


        fps=(int)timer.GetFPS();
        fpsq=(float)40/(float)fps;

                    


       
        //draw the terrain
        glLoadIdentity();


        
        //if(cam.pos.y>terra.sky.height*250) cam.pos.y=terra.sky.height*250;
                
        cam.update(1);
        if(cam.pos.y<terra.getIUSHeight(cam.pos.x,cam.pos.z)+50) cam.pos.y=terra.getIUSHeight(cam.pos.x,cam.pos.z)+50;
        if(cam.pos.y<(wat.height+30)) cam.pos.y=wat.height+30;
        cam.positionCamera();
            if(!firstdone){//Logo not yet shown
                       
                       showLogoScreen();
                       GK(VK_SPACE){
                                    InitPositions();
                                    initShadowTex();
                                    InitPositions();
                                    
                                    firstdone=true;
                       }
            }
//**************************************************                    
//1. Bildschirm                    
//**************************************************
            else{
                    if(settings[2]) glViewport(0,0,resx/2,resy);
                    //draw the terrain
                    glLoadIdentity();
            
            
                    
                    //if(cam.pos.y>terra.sky.height*250) cam.pos.y=terra.sky.height*250;
                            
                    cam.update(1);
                    if(cam.pos.y<terra.getIUSHeight(cam.pos.x,cam.pos.z)+50) cam.pos.y=terra.getIUSHeight(cam.pos.x,cam.pos.z)+50;
                    if(cam.pos.y<(wat.height+30)) cam.pos.y=wat.height+30;
                    cam.positionCamera();//*/
                    glColor3f(1,1,1);
                    //*****************************************************************
                    //Reflection
                    //*****************************************************************
                   
                    glPushMatrix();
                        double reflectPlane[] = {0.0f, -1.0f, 0.0f, wat.height};//only things below Clipping plane are drawn
                        glEnable(GL_CLIP_PLANE0);							// Turn on clipping for plane 0
                        glClipPlane(GL_CLIP_PLANE0, reflectPlane);          //Set plane as defined in reflectPlane
                        //glEnable(GL_BLEND);
                	    //glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);                     
                        glColor4f(1.0f, 1.0f, 1.0f, 0.7f);
                        glTranslatef(0.0,2*wat.height,0.0);                //Translate terrain so it is seen as reflection below the water surface
                        glScalef(1.0,-1.0,1.0);                             //Turn upside down
                        glEnable(GL_DEPTH_TEST);
                        glDepthFunc(GL_LESS);
                        
                       
                        
                        for(int x=0;x<modelnr;x++){
    
                            if(fabs(models[x].pos.x-cam.pos.x)*2<terra.MaxView && fabs(models[x].pos.z-cam.pos.z)*2<terra.MaxView){
                                  models[x].SetModelPos();
                                  terra.models[models[x].parentNR].RenderFrame();//Animate(int(floor(models[x].anim=0)),int(floor(models[x].anim=0))+1,(models[x].anim-int(floor(models[x].anim=0)))*100);
                                  glPopMatrix();
    
                            }
    
                        }
                       
                        
                        terra.renderTerrain(cam.pos);                       //Render terrain
                        sky.draw();
                        glDisable(GL_CLIP_PLANE0);
                    glPopMatrix();
                    
                    if(shader_Support)wat.draw(settings[1],0);
                    else wat.draw(false);
                    sky.draw();
                    terra.renderTerrain(cam.pos);
                   
                   //draw model shadows
                   /*if(shader_Support){
                           glEnable(GL_BLEND);
                        	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);  
                            glColor4f(0.0,0.0,0.0,0.75);
                            glBindShader(shadow_shd);
                            glUniform1iARB(glGUL(shadow_shd,"extrude"),1);
                            for(int x=0;x<modelnr;x++){
            
                                    if(fabs(models[x].pos.x-cam.pos.x)*2<terra.MaxView && fabs(models[x].pos.z-cam.pos.z)*2<terra.MaxView){
                                          models[x].SetModelPos();
                                          GLdouble modelMatrix[16]; // The model matrix.
                                         
                                          glGetDoublev(GL_MODELVIEW_MATRIX, modelMatrix); // Load the matricies and viewport.
                                          glUniform3fARB(glGUL(shadow_shd,"lightPos"),0.0,0.0,0.0);
                                          //glStencilFunc(GL_EQUAL,x,1);
                                          glDepthFunc(GL_GEQUAL);
                                          //glStencilOp(GL_KEEP,GL_KEEP,GL_REPLACE);
                                          
                                          //glColorMask(0,0,0,0);
                                          //glDepthMask(0);
                                          //glDisable(GL_CULL_FACE);
                                          //glCullFace(GL_BACK);                                  
                                          terra.models[models[x].parentNR].RenderShadowedFrame(0,shadow_shd);
                                          //terra.models[models[x].parentNR].RenderFrame(0);
                                          //glCullFace(GL_BACK);
                                          //glDepthMask(1);
                                          //glDepthFunc(GL_LESS);
                                          //glStencilFunc(GL_EQUAL,x,x);
                                          //glStencilFunc(GL_ALWAYS,1,1);
                                          //glStencilOp(GL_KEEP,GL_KEEP,GL_KEEP);
                                          
                                          //glColorMask(1,1,1,1);
                                          //terra.models[models[x].parentNR].RenderShadowedFrame(0,shadow_shd);
                                  
                                          glPopMatrix();
            
                                    }  
            
                            }
                          glUnbindShader();  
                          glDepthFunc(GL_LESS);
                          glDisable(GL_STENCIL_TEST);
                          glDisable(GL_BLEND);
                          glDisable(GL_CULL_FACE);
                          glDepthMask(1);
                          glColor3f(1.0,1.0,1.0);                    
                  }*/
                    //draw Models 
                    for(int x=0;x<modelnr;x++){
                            if(fabs(models[x].pos.x-cam.pos.x)*2<terra.MaxView && fabs(models[x].pos.z-cam.pos.z)*2<terra.MaxView){
                                  models[x].SetModelPos();
                                  terra.models[models[x].parentNR].RenderFrame();
                                  glPopMatrix();
                            }  
                    }
if(settings[2]){                 
//**************************************************                    
//2. Bildschirm                    
//**************************************************
        glViewport(resx/2,0,resx,resy);
        //draw the terrain
        glLoadIdentity();
        //if(cam.pos.y>terra.sky.height*250) cam.pos.y=terra.sky.height*250;
                
        cam.update(1);
        if(cam.pos.y<terra.getIUSHeight(cam.pos.x,cam.pos.z)+50) cam.pos.y=terra.getIUSHeight(cam.pos.x,cam.pos.z)+50;
        if(cam.pos.y<(wat.height+30)) cam.pos.y=wat.height+30;
        cam.positionCamera();
                                
                    glColor3f(1,1,1);
                    //*****************************************************************
                    //Reflection
                    //*****************************************************************
                   
                    glPushMatrix();
                        
                        glEnable(GL_CLIP_PLANE0);							// Turn on clipping for plane 0
                        glClipPlane(GL_CLIP_PLANE0, reflectPlane);          //Set plane as defined in reflectPlane
                        //glEnable(GL_BLEND);
                	    //glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);                     
                        glColor4f(1.0f, 1.0f, 1.0f, 0.7f);
                        glTranslatef(0.0,2*wat.height,0.0);                //Translate terrain so it is seen as reflection below the water surface
                        glScalef(1.0,-1.0,1.0);                             //Turn upside down
                        glEnable(GL_DEPTH_TEST);
                        glDepthFunc(GL_LESS);
                        
                       
                        
                        for(int x=0;x<modelnr;x++){
    
                            if(fabs(models[x].pos.x-cam.pos.x)*2<terra.MaxView && fabs(models[x].pos.z-cam.pos.z)*2<terra.MaxView){
                                  models[x].SetModelPos();
                                  terra.models[models[x].parentNR].RenderFrame();//Animate(int(floor(models[x].anim=0)),int(floor(models[x].anim=0))+1,(models[x].anim-int(floor(models[x].anim=0)))*100);
                                  glPopMatrix();
    
                            }
    
                        }
                       
                        
                        terra.renderTerrain(cam.pos);                       //Render terrain
                        sky.draw();
                        glDisable(GL_CLIP_PLANE0);
                    glPopMatrix();
                    
                    if(shader_Support && settings[2])wat.draw(settings[1],11);
                    
                    else wat.draw(false);
                    sky.draw();
                    terra.renderTerrain(cam.pos);
                   
                   //draw model shadows
                   /*if(shader_Support){
                           glEnable(GL_BLEND);
                        	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);  
                            glColor4f(0.0,0.0,0.0,0.75);
                            glBindShader(shadow_shd);
                            glUniform1iARB(glGUL(shadow_shd,"extrude"),1);
                            for(int x=0;x<modelnr;x++){
            
                                    if(fabs(models[x].pos.x-cam.pos.x)*2<terra.MaxView && fabs(models[x].pos.z-cam.pos.z)*2<terra.MaxView){
                                          models[x].SetModelPos();
                                          GLdouble modelMatrix[16]; // The model matrix.
                                         
                                          glGetDoublev(GL_MODELVIEW_MATRIX, modelMatrix); // Load the matricies and viewport.
                                          glUniform3fARB(glGUL(shadow_shd,"lightPos"),0.0,0.0,0.0);
                                          //glStencilFunc(GL_EQUAL,x,1);
                                          glDepthFunc(GL_GEQUAL);
                                          //glStencilOp(GL_KEEP,GL_KEEP,GL_REPLACE);
                                          
                                          //glColorMask(0,0,0,0);
                                          //glDepthMask(0);
                                          //glDisable(GL_CULL_FACE);
                                          //glCullFace(GL_BACK);                                  
                                          terra.models[models[x].parentNR].RenderShadowedFrame(0,shadow_shd);
                                          //terra.models[models[x].parentNR].RenderFrame(0);
                                          //glCullFace(GL_BACK);
                                          //glDepthMask(1);
                                          //glDepthFunc(GL_LESS);
                                          //glStencilFunc(GL_EQUAL,x,x);
                                          //glStencilFunc(GL_ALWAYS,1,1);
                                          //glStencilOp(GL_KEEP,GL_KEEP,GL_KEEP);
                                          
                                          //glColorMask(1,1,1,1);
                                          //terra.models[models[x].parentNR].RenderShadowedFrame(0,shadow_shd);
                                  
                                          glPopMatrix();
            
                                    }  
            
                            }
                          glUnbindShader();  
                          glDepthFunc(GL_LESS);
                          glDisable(GL_STENCIL_TEST);
                          glDisable(GL_BLEND);
                          glDisable(GL_CULL_FACE);
                          glDepthMask(1);
                          glColor3f(1.0,1.0,1.0);                    
                  }*/
                    //draw Models 
                    
                    for(int x=0;x<modelnr;x++){
                            if(fabs(models[x].pos.x-cam.pos.x)*2<terra.MaxView && fabs(models[x].pos.z-cam.pos.z)*2<terra.MaxView){
                                  models[x].SetModelPos();
                                  terra.models[models[x].parentNR].RenderFrame();
                                  glPopMatrix();
                            }  
                    }                    

                    glViewport(0,0,resx,resy);
}//if splitscreen 
                    if(multitex && settings[0]) antialias_Scene();
                    glLoadIdentity();
    
                    //********************************************************
                    //drawing done, so print everything needed to screen
                    glBindTex(ftex);
    
                    glPrint(255,0,0, 20,20,"FPS: %i   CPU: %i",fps,(int)(100*CPUusage()));
                    glPrint(255,0,0, 20,40,"x: %f  y: %f  z: %f",cam.pos.x, cam.pos.y,cam.pos.z);
                    glPrint(255,0,0, 20,60,"yrot: %i",(int)cam.yrot);
                    //glPrint(0,0,0,0,0,"");
                    
                    
                    
            }//else firstdone
        }//else GK(VK_F1)
        glFlush();
        return TRUE;                                                            // Keep Going
}
